unit Utils;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,
  Windows, // FindResource
  menus;
  //Registry;
  //ShellAPI ;

//  Windows, Messages,Classes, Sysutils, Forms, ShellAPI, Dialogs, SynEditHighlighter,
//  menus, Registry;

  
  
    // Added by MikeB
    procedure LoadFilefromResource(const FileName: string; ms: TMemoryStream);


implementation

uses
   MultiLangSupport;
   //graphics;
procedure LoadFilefromResource(const FileName: string; ms: TMemoryStream);
var
  HResInfo: HRSRC;
  hRes: THandle;
  Buffer: PChar;
  aName, Ext: string;

const
  ID_ERR_RESOURCE                  = 1510;
  

  ID_ERROR                         = 2012;
  
begin
  Ext := ExtractFileExt(FileName);
  Ext := copy(ext, 2, length(ext));
  aName := ChangeFileExt(ExtractFileName(FileName), '');
  HResInfo := FindResource(HInstance, pchar(aName), pchar(Ext));
  hres := LoadResource(HInstance, HResInfo);
  if HRes = 0 then
  begin
    //MessageBox(Application.MainForm.Handle,
    MessageBox(null,
      PChar(Format(Lang[ID_ERR_RESOURCE], [FileName, aName, Ext])),
      PChar(Lang[ID_ERROR]), MB_OK or MB_ICONERROR);
    exit;
  end;

  Buffer := LockResource(HRes);
  ms.clear;
  ms.WriteBuffer(Buffer[0], SizeofResource(HInstance, HResInfo));
  ms.Seek(0, 0);
  //UnlockResource(HRes);
  FreeResource(HRes);
end;


end.

