/*
  Name: fileDlg 
  Copyright: GPL
  Author: dwfree74@naver.com 
  Date: 27-11-04 09:13
  Description: ޴ ۼ, Ͽ ̾˷α  
*/

//#include <windows.h>

// start - dwfree74
#include "main.h" // ޴  
#include "BinToText.h" // BinToText Լ 
#include "TextToBin.h" // TextToBin Լ 

// end - dwfree74 


/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);


/*  Make the class name into a global variable  */
char szClassName[ ] = "WindowsApp";

HINSTANCE g_hInst;

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */


    /* The Window structure */
    g_hInst = hThisInstance;
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);//(HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "mFileTextTrans           ver 0.0.2",       /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           544,                 /* The programs width */
           375,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );
           
     MyHwnd = hwnd; //  ڵ  ѱ      

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);

// start - dwfree74
    menu = LoadMenu(hThisInstance, MAKEINTRESOURCE(ID_MENU));
    SetMenu(hwnd, menu);
// end - dwfree74 


    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    // start - dwfree74
       OPENFILENAME OFN; //б 
       OPENFILENAME SFN; //      
       char str[1024];
       char lpstrFile[MAX_PATH] ="";
       
       h_messenger = NULL; //  (޽ äâ) ڵ 

       //CheckMenuItem(menu,IDM_DOSCONSOLE, MF_BYCOMMAND | MF_CHECKED);       
    // end - dwfree74 

    switch (message)                  /* handle the messages */
    {
      // start - dwfree74
       case WM_CREATE:
            hEdit = CreateWindow("edit", NULL, WS_CHILD | WS_VISIBLE | WS_BORDER,
                    10, 10, 200, 25, hwnd, (HMENU)ID_EDIT, g_hInst, NULL); 
            hTButton = CreateWindow("button", "ID Է", WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                    250, 10, 100, 25, hwnd, (HMENU)ID_TBUTTON, g_hInst, NULL); 

           return 0;
       case WM_COMMAND:
           switch( wParam )
           {
             Sleep(1);
             
             case ID_TBUTTON:
                 
                GetWindowText(hEdit, str, 1024);
               
                 t_msg = (char *)malloc(1024);
                 sprintf(t_msg, "%s ԰ ȭ", str);
                 MessageBox(hwnd, t_msg, "ư", MB_OK); 
                 return 0; 
             
  
             case IDM_DOSCONSOLE:
                 if (wParam == IDM_DOSCONSOLE) 
                 {
                     if (DOSCONSOLE_CHECK == false)
                     {
                         DOSCONSOLE_CHECK = true;
                         CheckMenuItem(menu,IDM_DOSCONSOLE, MF_BYCOMMAND | MF_CHECKED); 
                     }    
                     else
                     {
                         DOSCONSOLE_CHECK = false;
                         CheckMenuItem(menu,IDM_DOSCONSOLE, MF_BYCOMMAND | MF_UNCHECKED);
                     }    
                 }    
                 return 0;
                   
             case IDM_NATEONM:
                 
             case IDM_BINTOTEXT:
                 
                 CheckMenuItem(menu,IDM_NATEONM, MF_BYCOMMAND | MF_CHECKED);
                 //===========================================================                 
                 
                 if (wParam == IDM_BINTOTEXT) SIMUL_CHECK = true;
                 else if(wParam == IDM_NATEONM) SIMUL_CHECK = false;
                 
                 memset(&OFN, 0, sizeof(OPENFILENAME));
                 OFN.lStructSize = sizeof(OPENFILENAME);
                 OFN.hwndOwner=hwnd;
                 OFN.lpstrFilter = "(*.*)\0*.*\0";
                 OFN.lpstrFile = lpstrFile;
                 OFN.nMaxFile = MAX_PATH;
                 if (GetOpenFileName(&OFN)!=0)
                 {
                     Sleep(1);
                     BinToText(OFN.lpstrFile);
                     wsprintf(str, "%s  ߽ϴ.", OFN.lpstrFile);
                     MessageBox(hwnd, str, "BinToText ", MB_OK); 
                 }
                 
                 return 0;

             case IDM_TEXTTOBIN:
                 memset(&SFN, 0, sizeof(OPENFILENAME));
                 SFN.lStructSize = sizeof(OPENFILENAME);
                 SFN.hwndOwner=hwnd;
                 SFN.lpstrFilter = "(*.*)\0*.*\0";
                 SFN.lpstrFile = lpstrFile;
                 SFN.nMaxFile = MAX_PATH;
                 if (GetSaveFileName(&SFN)!=0)
                 {
                     TextToBin("Result.txt", SFN.lpstrFile); 
                     
                     wsprintf(str, "%s  ߽ϴ.", SFN.lpstrFile);
                     MessageBox(hwnd, str, "TextToBin ", MB_OK);
                     
                 }
                 
                 return 0;

                 


             //case IDM_FILENEW:
                     
             //case IDM_FILESAVEAS:
             //case IDM_FILEPRINT:
             //case IDM_FILEPAGESETUP:
             //case IDM_FILEPRINTSETUP:

             //case IDM_EDITUNDO:
             //case IDM_EDITCUT:
             //case IDM_EDITCOPY:
             //case IDM_EDITPASTE:
/*                 
             case IDM_EDITDELETE:
                  MessageBox( hwnd, (LPSTR) "Function Not Yet Implemented.",
                              (LPSTR) szClassName,
                              MB_ICONINFORMATION | MB_OK );
                  return 0;
*/                  
/*
             case IDM_HELPCONTENTS:
                  WinHelp( hwnd, (LPSTR) "HELPFILE.HLP",
                           HELP_CONTENTS, 0L );
                  return 0;
*/                  
/*
             case IDM_HELPSEARCH:
                  WinHelp( hwnd, (LPSTR) "HELPFILE.HLP",
                           HELP_PARTIALKEY, 0L );
                  return 0;
*/                  
/*
             case IDM_HELPHELP:
                  WinHelp( hwnd, (LPSTR) "HELPFILE.HLP",
                           HELP_HELPONHELP, 0L );
                  return 0;
*/
             case IDM_FILEEXIT:
                  SendMessage( hwnd, WM_CLOSE, 0, 0L ); //  
                  return 0;

             case IDM_HELPABOUT:
                 
                  //EnumWindows(m_NateOn_EnumWindowsProc1, NULL); 
                  
                  wsprintf(str, "mFileTextTrans ver 0.01\n\n http://kldp.net/projects/mfiletexttrans/ \n\n made by dwfree74@naver.com");
                  MessageBox (NULL,  str, "About", 1);
                  return 0;

           }
           break;

      case WM_CLOSE:
           DestroyWindow( hwnd );
           return 0;      
      // end - dwfree74
                   
        case WM_DESTROY:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}


